package com.example.onomatopoeiaback.controller;

import com.example.onomatopoeiaback.domain.qrcode.QrCode;
import com.example.onomatopoeiaback.security.Auth;
import com.example.onomatopoeiaback.service.QrCodeService;
import io.swagger.v3.oas.annotations.security.SecurityRequirement;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.Authentication;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/qr_code")
public class QrCodeController {
    final
    QrCodeService qrCodeService;

    public QrCodeController(QrCodeService qrCodeService) {
        this.qrCodeService = qrCodeService;
    }

    @PostMapping("/create")
    @SecurityRequirement(name = "basicAuth")
    public ResponseEntity<QrCode> createQrCode(Authentication authentication, @RequestParam String name) {
        Auth.getEmployee(authentication);
        return ResponseEntity.ok(qrCodeService.createQrCode(name));
    }
}
