package com.example.onomatopoeiaback.repository;

import com.example.onomatopoeiaback.domain.visit.Visit;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

@Repository
public interface VisitRepository extends JpaRepository<Visit, Long> {
    /**
     * Возвращает страницу посещений для указанного сотрудника.
     *
     * @param employeeId ID сотрудника, для которого нужно получить посещения.
     * @param pageable   Объект Pageable, содержащий информацию о пагинации (limit и offset).
     * @return Страница с посещениями, соответствующими критериям.
     */
    Page<Visit> findByEmployeeId(Long employeeId, Pageable pageable);
}
