package com.example.onomatopoeiaback.security;

import com.example.onomatopoeiaback.domain.employee.Employee;
import com.example.onomatopoeiaback.exceptions.UnauthorizedException;
import com.example.onomatopoeiaback.repository.EmployeeRepository;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.stereotype.Service;

import java.util.Optional;

@Service("employeeDetailsService")
public class CustomEmployeeDetailsService implements UserDetailsService {
    final
    EmployeeRepository employeeRepository;

    public CustomEmployeeDetailsService(EmployeeRepository employeeRepository) {
        this.employeeRepository = employeeRepository;
    }

    @Override
    public CustomEmployeeDetails loadUserByUsername(String login) throws UnauthorizedException {
        Optional<Employee> employeeOptional = employeeRepository.findByLogin(login);
        return employeeOptional.map(CustomEmployeeDetails::new).orElse(null);
    }
}
